// ServiceMFCDlg.cpp : implementation file
//


#include "stdafx.h"
#include "ServiceMFC.h"
#include "ServiceMFCDlg.h"
#include ".\servicemfcdlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CServiceMFCDlg dialog



CServiceMFCDlg::CServiceMFCDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CServiceMFCDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CServiceMFCDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDIT1, m_edHost);
	DDX_Control(pDX, IDC_BUTTON1, m_btGetServices);
	DDX_Control(pDX, IDC_LIST2, m_lcServicesList);
	DDX_Control(pDX, IDC_CHECK1, m_cbWin32);
	DDX_Control(pDX, IDC_CHECK2, m_cbKernel);
	DDX_Control(pDX, IDC_BUTTON3, m_btStart);
	DDX_Control(pDX, IDC_BUTTON4, m_btStop);
	DDX_Control(pDX, IDC_BUTTON5, m_btPause);
	DDX_Control(pDX, IDC_BUTTON6, m_btContinue);
	DDX_Control(pDX, IDC_STATIC1, m_stServiceName);
}

BEGIN_MESSAGE_MAP(CServiceMFCDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON1, OnBnClickedButton1)
	ON_NOTIFY(HDN_ITEMCHANGED, 0, OnHdnItemchangedList2)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_LIST2, OnLvnItemchangedList2)
	ON_BN_CLICKED(IDC_BUTTON3, OnBnClickedButton3)
	ON_BN_CLICKED(IDC_BUTTON4, OnBnClickedButton4)
	ON_BN_CLICKED(IDC_BUTTON5, OnBnClickedButton5)
	ON_BN_CLICKED(IDC_BUTTON6, OnBnClickedButton6)
END_MESSAGE_MAP()


// CServiceMFCDlg message handlers

BOOL CServiceMFCDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	//Initialize ListCtrl
	CRect rect;
	m_lcServicesList.GetClientRect(&rect);
	int nColInterval = rect.Width()/5;
	m_lcServicesList.InsertColumn(0, _T("ServiceName"), LVCFMT_LEFT, nColInterval);
	m_lcServicesList.InsertColumn(1, _T("DisplayName"), LVCFMT_LEFT, 2*nColInterval);
	m_lcServicesList.InsertColumn(2, _T("Status"), LVCFMT_LEFT,nColInterval);
	m_lcServicesList.InsertColumn(3, _T("Type"), LVCFMT_LEFT, nColInterval);	
	
	//Describe Service Status
	m_stServiceStatus[SERVICE_CONTINUE_PENDING]="Pending Continue";
	m_stServiceStatus[SERVICE_PAUSE_PENDING]="Pending Pause";
	m_stServiceStatus[SERVICE_PAUSED]="Paused";
	m_stServiceStatus[SERVICE_RUNNING]="Runnig";
	m_stServiceStatus[SERVICE_START_PENDING]="Starting";
	m_stServiceStatus[SERVICE_STOP_PENDING]="Stopping";
	m_stServiceStatus[SERVICE_STOPPED]="Stoped";
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CServiceMFCDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CServiceMFCDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CServiceMFCDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CServiceMFCDlg::OnBnClickedButton1()
{
	m_btStart.EnableWindow(false);
	m_btStop.EnableWindow(false);
	m_btPause.EnableWindow(false);
	m_btContinue.EnableWindow(false);

	CString m_stHost;
	m_edHost.GetWindowText(m_stHost);
	if (m_stHost.GetLength()<=0)
	{
		m_stHost=".";
	};

	schSCManager=OpenSCManager(m_stHost,NULL,SC_MANAGER_ENUMERATE_SERVICE);    
  
	if (schSCManager==NULL){
		MessageBox("Can't open Service Manager");
	}
	else
	{
		FillListCtrl();
	};
};
void CServiceMFCDlg::FillListCtrl()
{
	m_lcServicesList.DeleteAllItems();	
  	DWORD m_dwServiceType;
	m_dwServiceType=SERVICE_WIN32|SERVICE_DRIVER;
	if (m_cbWin32.GetCheck()==true)
		m_dwServiceType=SERVICE_WIN32;
	if (m_cbKernel.GetCheck()==true)
		m_dwServiceType=SERVICE_DRIVER;
	if ((m_cbWin32.GetCheck()==true)&&(m_cbKernel.GetCheck()==true))
		m_dwServiceType=SERVICE_WIN32|SERVICE_DRIVER;

	ENUM_SERVICE_STATUS service;
    DWORD dwBytesNeeded = 0;
	DWORD dwServicesReturned = 0;
	DWORD dwResumedHandle = 0;
		
	// Query services
	BOOL retVal = EnumServicesStatus(schSCManager, m_dwServiceType, SERVICE_STATE_ALL, 
			&service, sizeof(ENUM_SERVICE_STATUS), &dwBytesNeeded, &dwServicesReturned,	&dwResumedHandle);
	
	if (!retVal) {
    // Need big buffer
		if (ERROR_MORE_DATA == GetLastError()) {
			// Set the buffer
			DWORD dwBytes = sizeof(ENUM_SERVICE_STATUS) + dwBytesNeeded;
			/*if (pServices!=NULL)
                  delete[] pServices;
			pServices = NULL;
			pServices = new ENUM_SERVICE_STATUS [dwBytes];
*/
	// Now query again for services
			EnumServicesStatus(schSCManager, SERVICE_WIN32 | SERVICE_DRIVER, 
				SERVICE_STATE_ALL, pServices, dwBytes, &dwBytesNeeded, 
				&dwServicesReturned, &dwResumedHandle);
			
			LVITEM lvi;
			CString strItem;
     // now traverse each service to get information
			for (unsigned i = 0; i < dwServicesReturned; i++) {
			// Insert the first item
				lvi.mask = LVIF_TEXT;
				strItem = pServices[i].lpServiceName;
				lvi.iItem = i;
				lvi.iSubItem = 0;
				lvi.pszText = (LPTSTR)(LPCTSTR)(strItem);
				m_lcServicesList.InsertItem(&lvi);
		// Set subitem 1
				strItem = pServices[i].lpDisplayName;
				lvi.iSubItem = 1;
				lvi.pszText = (LPTSTR)(LPCTSTR)(strItem);
				m_lcServicesList.SetItem(&lvi);
			//set subitem 2
				strItem = m_stServiceStatus[pServices[i].ServiceStatus.dwCurrentState];
				lvi.iSubItem = 2;
				lvi.pszText = (LPTSTR)(LPCTSTR)(strItem);
				m_lcServicesList.SetItem(&lvi);
			//set subitem 3

				switch (pServices[i].ServiceStatus.dwServiceType)
				{
				case SERVICE_FILE_SYSTEM_DRIVER:
					strItem = "File System Driver";
					break;
				case SERVICE_KERNEL_DRIVER:
					strItem = "Kernel Driver";
					break;
				case SERVICE_WIN32_OWN_PROCESS:
					strItem = "Own Service Proces";
					break;
				case SERVICE_WIN32_SHARE_PROCESS:
					strItem = "Shared Process";
					break;
				case SERVICE_INTERACTIVE_PROCESS:
					strItem = "Interactive process";
					break;
				default:
					strItem="Non defined";
				};
				lvi.iSubItem = 3;
				lvi.pszText = (LPTSTR)(LPCTSTR)(strItem);
				m_lcServicesList.SetItem(&lvi);
			};//end for

			//delete [] pServices;
			//pServices = NULL;
		};//end if error more data
	}
	else
	{
		MessageBox("Can't retrieve services");
	};//end if retval

}

void CServiceMFCDlg::OnHdnItemchangedList2(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMHEADER phdr = reinterpret_cast<LPNMHEADER>(pNMHDR);
	*pResult = 0;
}

void CServiceMFCDlg::OnLvnItemchangedList2(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);
	
	// Get the selected items in the control
	POSITION m_position = m_lcServicesList.GetFirstSelectedItemPosition();
	int m_iIndex;
	CString strn;
	m_iIndex = m_lcServicesList.GetNextSelectedItem(m_position);
	strn=pServices[m_iIndex].lpServiceName;
	m_stServiceName.SetWindowText(_T(strn));
	if ((pServices[m_iIndex].ServiceStatus.dwControlsAccepted==SERVICE_ACCEPT_PAUSE_CONTINUE))
	{
		m_btPause.EnableWindow(true);
		m_btContinue.EnableWindow(true);
	}
	else
	{
		m_btPause.EnableWindow(false);
		m_btContinue.EnableWindow(false);
	};
	
	if (pServices[m_iIndex].ServiceStatus.dwControlsAccepted==SERVICE_ACCEPT_STOP)
		m_btStop.EnableWindow(true);
	else
		m_btStop.EnableWindow(false);

	if (pServices[m_iIndex].ServiceStatus.dwCurrentState==SERVICE_STOPPED)
		m_btStart.EnableWindow(true);
	else
		m_btStart.EnableWindow(false);
	
	*pResult = 0;
}

void CServiceMFCDlg::PostNcDestroy()
{
/*	delete [] pServices;
	pServices = NULL;

*/	CDialog::PostNcDestroy();
}

void CServiceMFCDlg::OnBnClickedButton3()
{
    SERVICE_STATUS ssStatus; 
    DWORD dwOldCheckPoint; 
    DWORD dwStartTickCount;
    DWORD dwWaitTime;
    DWORD dwStatus;
	SC_HANDLE schService;

	POSITION m_position = m_lcServicesList.GetFirstSelectedItemPosition();
	int m_iIndex;
	CString strn;
	m_iIndex = m_lcServicesList.GetNextSelectedItem(m_position);
	strn=pServices[m_iIndex].lpServiceName;
    
	schService = OpenService( 
        schSCManager,			// SCM database 
        strn,					// service name
        SERVICE_ALL_ACCESS); 
 
    if (schService == NULL) 
    { 
        MessageBox("Can't open Service");
		return;
    }
 
    if (!StartService(
            schService,  // handle to service 
            0,           // number of arguments 
            NULL) )      // no arguments 
    {
        MessageBox("Can't open Service");
		return;
	}
    else 
    {
		m_stServiceName.SetWindowText(_T("Service start pending.")); 
    }
 
    // Check the status until the service is no longer start pending. 
 
    if (!QueryServiceStatus( 
            schService,   // handle to service 
            &ssStatus) )  // address of status information structure
    {
        //MyErrorExit("QueryServiceStatus"); 
    }
 
    // Save the tick count and initial checkpoint.

    dwStartTickCount = GetTickCount();
    dwOldCheckPoint = ssStatus.dwCheckPoint;

    while (ssStatus.dwCurrentState == SERVICE_START_PENDING) 
    { 
        // Do not wait longer than the wait hint. A good interval is 
        // one tenth the wait hint, but no less than 1 second and no 
        // more than 10 seconds. 
 
        dwWaitTime = ssStatus.dwWaitHint / 10;

        if( dwWaitTime < 1000 )
            dwWaitTime = 1000;
        else if ( dwWaitTime > 10000 )
            dwWaitTime = 10000;

        Sleep( dwWaitTime );

        // Check the status again. 
 
        if (!QueryServiceStatus( 
                schService,   // handle to service 
                &ssStatus) )  // address of structure
            break; 
 
        if ( ssStatus.dwCheckPoint > dwOldCheckPoint )
        {
            // The service is making progress.

            dwStartTickCount = GetTickCount();
            dwOldCheckPoint = ssStatus.dwCheckPoint;
        }
        else
        {
            if(GetTickCount()-dwStartTickCount > ssStatus.dwWaitHint)
            {
                // No progress made within the wait hint
                break;
            }
        }
    } 

    if (ssStatus.dwCurrentState == SERVICE_RUNNING) 
    {
		m_stServiceName.SetWindowText(_T(strn));
		FillListCtrl();
		m_lcServicesList.SetItemState(m_iIndex, LVIS_SELECTED, LVIS_SELECTED | LVIS_FOCUSED);
			if ((pServices[m_iIndex].ServiceStatus.dwControlsAccepted==SERVICE_ACCEPT_PAUSE_CONTINUE))
	{
		m_btPause.EnableWindow(true);
		m_btContinue.EnableWindow(true);
	}
	else
	{
		m_btPause.EnableWindow(false);
		m_btContinue.EnableWindow(false);
	};
	
	if (pServices[m_iIndex].ServiceStatus.dwControlsAccepted==SERVICE_ACCEPT_STOP)
		m_btStop.EnableWindow(true);
	else
		m_btStop.EnableWindow(false);

	if (pServices[m_iIndex].ServiceStatus.dwCurrentState==SERVICE_STOPPED)
		m_btStart.EnableWindow(true);
	else
		m_btStart.EnableWindow(false);
    }
    else 
    { 
		MessageBox("Service not started");
    } 
 
    CloseServiceHandle(schService); 
}

void CServiceMFCDlg::ControlRequest(DWORD fdwControl)
{
	SERVICE_STATUS ssStatus; 
    DWORD fdwAccess; 
    
	SC_HANDLE schService;

	DWORD dwStartTickCount, dwWaitTime;
    DWORD dwOldCheckPoint; 
    DWORD dwStatus;
	DWORD waitStatus[2];
	CString waitString;

	POSITION m_position = m_lcServicesList.GetFirstSelectedItemPosition();
	int m_iIndex;
	CString strn;
	m_iIndex = m_lcServicesList.GetNextSelectedItem(m_position);
	strn=pServices[m_iIndex].lpServiceName;
    // The required service object access depends on the control. 
 
    switch (fdwControl) 
    { 
        case SERVICE_CONTROL_STOP: 
            fdwAccess = SERVICE_STOP;
			waitStatus[0]=SERVICE_STOP_PENDING;
			waitStatus[1]=SERVICE_STOPPED;
			waitString="Service stopping";
            break; 
 
        case SERVICE_CONTROL_PAUSE: 
            fdwAccess = SERVICE_PAUSE_CONTINUE; 
			waitStatus[0]=SERVICE_PAUSE_PENDING;
			waitStatus[1]=SERVICE_PAUSED;
			waitString="Service pausing";

			break; 

        case SERVICE_CONTROL_CONTINUE: 
            fdwAccess = SERVICE_PAUSE_CONTINUE; 
			waitStatus[0]=SERVICE_CONTINUE_PENDING;
			waitStatus[1]=SERVICE_RUNNING;
			waitString="Service continuing";

			break; 
 
        case SERVICE_CONTROL_INTERROGATE: 
            fdwAccess = SERVICE_INTERROGATE; 
			waitStatus[0]=SERVICE_PAUSE_PENDING;
			waitStatus[1]=SERVICE_PAUSED;
			waitString="Service interrogating";			
            break; 
 
        default: 
            fdwAccess = SERVICE_INTERROGATE; 
    } 
 
    // Open a handle to the service. 
 
    schService = OpenService( 
        schSCManager,        // SCManager database 
        strn,        // name of service 
        fdwAccess);          // specify access 
    if (schService == NULL) 
        MessageBox("Can't open service");
 
    // Send a control value to the service. 
 
    if (! ControlService( 
            schService,   // handle to service 
            fdwControl,   // control value to send 
            &ssStatus) )  // address of status info 
    {
        MessageBox("Can't send command to service");
    }
	else
	{
		dwStartTickCount = GetTickCount();
		dwOldCheckPoint = ssStatus.dwCheckPoint;

		while (ssStatus.dwCurrentState == waitStatus[0]) 
		{ 
        // Do not wait longer than the wait hint. A good interval is 
        // one tenth the wait hint, but no less than 1 second and no 
        // more than 10 seconds. 
			m_stServiceName.SetWindowText(_T(waitString));
			dwWaitTime = ssStatus.dwWaitHint / 10;

			if( dwWaitTime < 1000 )
				dwWaitTime = 1000;
			else if ( dwWaitTime > 10000 )
				dwWaitTime = 10000;

			Sleep( dwWaitTime );

        // Check the status again. 
 
			if (!QueryServiceStatus( 
				    schService,   // handle to service 
					&ssStatus) )  // address of structure
				break; 
 
			if ( ssStatus.dwCheckPoint > dwOldCheckPoint )
			{
            // The service is making progress.

				dwStartTickCount = GetTickCount();
				dwOldCheckPoint = ssStatus.dwCheckPoint;
			}
			else
			{
				if(GetTickCount()-dwStartTickCount > ssStatus.dwWaitHint)
				{
					// No progress made within the wait hint
					break;
				}
			}
		} 

//		if (ssStatus.dwCurrentState == waitStatus[1]) 
//		{
			m_stServiceName.SetWindowText(_T(strn));
			FillListCtrl();
			m_lcServicesList.SetItemState(m_iIndex, LVIS_SELECTED, LVIS_SELECTED | LVIS_FOCUSED);
			if ((pServices[m_iIndex].ServiceStatus.dwControlsAccepted==SERVICE_ACCEPT_PAUSE_CONTINUE))
			{
				m_btPause.EnableWindow(true);
				m_btContinue.EnableWindow(true);
			}
			else
			{
				m_btPause.EnableWindow(false);
				m_btContinue.EnableWindow(false);
			};
	
			if (pServices[m_iIndex].ServiceStatus.dwControlsAccepted==SERVICE_ACCEPT_STOP)
				m_btStop.EnableWindow(true);
			else
				m_btStop.EnableWindow(false);

			if (pServices[m_iIndex].ServiceStatus.dwCurrentState==SERVICE_STOPPED)
				m_btStart.EnableWindow(true);
			else
				m_btStart.EnableWindow(false);
/*		}
		else 
		{ 
			MessageBox("Command not started");
		} 
*/	}

    CloseServiceHandle(schService); 

 
    return; 

}

void CServiceMFCDlg::OnBnClickedButton4()
{
	ControlRequest(SERVICE_CONTROL_STOP);
}

void CServiceMFCDlg::OnBnClickedButton5()
{
	ControlRequest(SERVICE_CONTROL_PAUSE);
}

void CServiceMFCDlg::OnBnClickedButton6()
{
		ControlRequest(SERVICE_CONTROL_CONTINUE);
}
